import copy 

class Marker:
    '''A simple class to enumerate the possible game pieces'''
    NONE, X, O = range(3)
    
    @staticmethod
    def opponent(marker):
        '''Return the opponent marker of the given one'''
        if marker == Marker.X:
            return Marker.O
        elif marker == Marker.O:
            return Marker.X
        else:
            assert False, 'No opponent marker'

class Board:
    '''The Tic-Tac-Toe game board class.'''
                  
    def __init__(self, board = None):
        '''Create a new game board, possibly with an existing board.'''
        if board is None:
            # (The following line makes use notation known as 
            # "list comprehensions"). 
            self.board = [[Marker.NONE]*3 for i in range(3)]
        else:
            self.board = copy.deepcopy(board.board)
        
                                    
    def __str__(self):
        '''
        Return a string representation of Tic-Tac-Toe board. 
        This method is handy for debugging.
        '''
        # TODO: implement 
        pass

    def __eq__(self, board2):
        '''Return True if this board is equal board2, False otherwise.'''
        # TODO: implement 
        pass    
    
    def is_empty(self):
        '''
        Return True if this board contains only Marker.NONE entries, and
        False otherwise
        '''
        # TODO: implement
        pass
    
    def is_full(self):
        '''
        Return True if each position in the board contains Marker.X 
        or Marker.O, and False otherwise. 
        '''
        # TODO: implement
        pass
    
    def get_key(self):
        '''
        Return a a numeric representation of the board, which
        can be used as a key in a dictionary. This method guarantees that
        it will return different values for boards that are not equal.
        '''
        key = 0
        for row in self.board:
            for elt in row:
                key = (key + elt)*3
        return key        
    
    def is_game_over(self): 
        '''
        Return a 2-tuple that indicates whether the game is over and who won.
        The first element is True if the game is over, and False otherwise. 
        If the first element is True, then the second element indicates who
        won the game: Marker.X, Marker.O, or Marker.NONE (for a tie). If the
        first element is False, then the second element is Marker.NONE. 
        '''
        # TODO: implement
        pass
